#!/usr/local/bin/perl 


#-------------------------------------------------------  INIT VARIABLES
%in;				#-----  Xg


@userNames;					#[U[̔z
@titles;					#^Cg̔z
@messages;					#bZ[W̔z
@ips;						#IPAhX̔z
@update;					#XV̔z

$mesLength = 0;				#݂̃bZ[W̒

###########################################  Cuǂݍ
require "./messages.sys";
require "./settings.sys";


#---------------------------------------------
#					t@CbNmF
#---------------------------------------------
for( $index = 0; $index < $settings::LOCK_RETRY; $index++ )
{
	#-----  bNĂȂ
	if( &getFileLock() == 0 )
	{
		last;
	}
	
	#-----  bҋ@
	my( $now ) = time();
	while( ( $now + 1 ) > time() ){}
}

#-----  gCɎsꍇ
if( $index >= $settings::LOCK_RETRY )
{
	&showError( $messages::ERR_BUSY_TITLE, $messages::ERR_BUSY_MSG );
	exit(0);
}

#---------------------------------------------
#					t@C̃I[v
#---------------------------------------------
#-----  bZ[Wt@C̃I[v
if( !open( _MSFILE, $settings::FILENAME ) )
{
	&showError( $messages::ERR_DATNOOPEN_TITLE, $messages::ERR_DATNOOPEN_MSG );
	exit( 0 );
}

$index = 0;

#-----  bZ[Wt@C̓ez֊i[
while( <_MSFILE> )
{
	my( $tmpStr ) = $_;
	my( @tmpArray ) = split( /,/, $tmpStr );
	
	@userNames[$index] = @tmpArray[0];
    @titles[$index]    = @tmpArray[1];
    @messages[$index]  = @tmpArray[2];
    @ips[$index]       = @tmpArray[3];
    @update[$index]    = @tmpArray[4];
    $index++;
}

$mesLength = $index;


close( _MSFILE );


&showMessageResult;


#-------------------------------------------------------  IPAhX`FbN֐
sub ipCheck
{
	if( $ipLog == 0 )
	{
		return "";
	}
	
	return $ENV{"REMOTE_ADDR"};
}


#-------------------------------------------------------
#  f[^t@C̃bN󋵂擾
#-------------------------------------------------------
sub getFileLock
{
	my( $lockStat );
	
	#-----  bNt@C̃I[v
	if( !open( _LCFILE, "<" . $settings::LOCKFILENAME ) )
	{
		&showError( $messages::ERR_LOKNOOPEN_TITLE, $messages::ERR_LOKNOOPEN_MSG );
		exit(0);
	}
	
	$lockStat = <_LCFILE>;
	close(_LCFILE);
	
	return $lockStat;
}


#-------------------------------------------------------  ej[\֐
sub showMessageResult
{
	print "Content-type:text/html\n\n";
	
	print "<HTML>\n";
	print "<HEAD>\n";
	print "<META http-equiv='Content-Type' content='text/html; charset=Shift_JIS'>\n";
	print "<LINK REL='stylesheet' TYPE='text/css' HREF='./../css/style_main.css'>\n";
	print "<SCRIPT SRC='./../javaScript/msg_imp.js'></SCRIPT>\n";
	print "</HEAD>\n";
	print "\n";
	print "<BODY TEXT='#000055' BGCOLOR='#FFFFFF' LINK='#000055' ALINK='#FFFFFF' VLINK='#000055' CLASS='Body_Normal' ONLOAD='JavaScript:reloadControl()'>\n";
	print "  <TABLE WIDTH='100%' BORDER='0' CELLSPACING='0' CELLPADDING='0'>\n";
	print "    <TR HEIGHT='10'>\n";
	print "      <TD COLSPAN='3'></TD>\n";
	print "    </TR>\n";
	
	
	for( $index = 0; $index < $mesLength; $index++ )
	{
		print "    <TR HEIGHT='10'>\n";
		print "      <TD WIDTH='10'></TD>\n";
		print "      <TD>\n";
		print "        <TABLE WIDTH='100%' BORDER='0' CELLSPACING='0' CELLPADDING='1'><TR><TD WIDTH='100%' HEIGHT='20' BGCOLOR='#000055' CLASS='Line_Normal'>\n";
		print "          <TABLE WIDTH='100%' BORDER='0' CELLSPACING='2' BGCOLOR='#AAAAFF' CLASS='Box_Normal'>\n";
		print "            <TR HEIGHT='20'>\n";
		print "              <TD>\n";
		print "                <TABLE HEIGHT='100%' BORDER='0' CELLSPACING='0' CELLPADDING='1' BGCOLOR='#000055' CLASS='Line_Normal'><TR><TD>\n";
		print "                  <TABLE HEIGHT='100%' BORDER='0' CELLSPACING='0' BGCOLOR='#FFFFFF' CLASS='Body_Normal'><TR><TD>\n";
		print "                    <FONT SIZE='3'><DIV CLASS='Txt_Normal'>\n";
		print "                      &nbsp;<img src='./../img/ball3.gif' WIDTH='11' HEIGHT='8'>&nbsp; " . $titles[$index] . "\n";
		print "                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
		print "                    </DIV></FONT>\n";
		print "                  </TD></TR></TABLE>\n";
		print "                </TD></TR></TABLE>\n";
		print "              </TD>\n";
		print "            </TR>\n";
		print "            <TR>\n";
		print "              <TD ALIGN='LEFT' VALIGN='TOP'>\n";
		print "                <TABLE WIDTH='100%' BORDER='0' CELLSPACING='0' CELLPADDING='0'>\n";
		print "                  <TR>\n";
		print "                    <TD WIDTH='10'></TD>\n";
		print "                    <TD ALIGN='LEFT'><FONT SIZE='3'><DIV CLASS='Txt_Normal'>\n";
		print "                      " . $messages[$index] . "\n";
		print "                    </DIV></FONT></TD>\n";
		print "                  </TR>\n";
		print "                </TABLE>\n";
		print "              </TD>\n";
		print "            </TR>\n";
		print "            <TR HEIGHT='20'>\n";
		print "              <TD ALIGN='RIGHT'><FONT SIZE='3'><DIV CLASS='Txt_Normal'>\n";
		print "                <B>[U[F" . $userNames[$index] . "</B>&nbsp;&nbsp;" . $update[$index] . "\n";
		print "              </DIV></FONT></TD>\n";
		print "            </TR>\n";
		print "          </TABLE>\n";
		print "        </TD></TR></TABLE>\n";
		print "      </TD>\n";
		print "      <TD WIDTH='10'></TD>\n";
		print "    </TR>\n";
		print "    <TR HEIGHT='5'>\n";
		print "      <TD COLSPAN='3'></TD>\n";
		print "    </TR>\n";
	}
	
	
	print "  </TABLE>\n";
	print "</BODY>\n";
	print "</HTML>\n";
}


#-------------------------------------------------------  G[bZ[W\֐
sub showError
{
	print "Content-type:text/html\n\n";
	
	print "<HTML>\n";
	print "<HEAD>\n";
	print "<META http-equiv='Content-Type' content='text/html; charset=Shift_JIS'>\n";
	print "<LINK REL='stylesheet' TYPE='text/css' HREF='./../css/style_main.css'>\n";
	print "</HEAD>\n";
	print "\n";
	print "<BODY TEXT='#FFFFFF' BGCOLOR='#55000' LINK='#FFFFFF' ALINK='#FFFFFF' VLINK='#FFFFFF' CLASS='Body_Error'>\n";
	print "  <TABLE WIDTH='100%' HEIGHT='100%' BORDER='0' CELLSPACING='0' CELLPADDING='0'>\n";
	print "    <TR HEIGHT='20'>\n";
	print "      <TD BGCOLOR='#000000' VALIGN='TOP' CLASS='Line_Error'>\n";
	print "        <TABLE WIDTH='100%' HEIGHT='20' BORDER='0' CELLSPACING='1'>\n";
	print "          <TR BGCOLOR='#220000' CLASS='Box_Error'>\n";
	print "            <TD ALIGN='CENTER' VALIGN='MIDDLE'><FONT SIZE='3' COLOR='#FFFFFF'>\n";
	print "              <DIV CLASS='Txt_Reverse'><B>" . @_[0] . "</B></DIV></FONT>\n";
	print "            </TD>\n";
	print "          </TR>\n";
	print "        </TABLE>\n";
	print "      </TD>\n";
	print "    </TR>\n";
	print "    <TR HEIGHT='20'>\n";
	print "      <TD></TD>\n";
	print "    </TR>\n";
	print "    <TR HEIGHT='40'>\n";
	print "      <TD ALIGN='CENTER' VALIGN='TOP'><FONT SIZE='3'><DIV CLASS='Txt_Reverse'>\n";
	print "        " . @_[1] . "\n";
	print "      </DIV></FONT></TD>\n";
	print "    </TR>\n";
	print "    <TR>\n";
	print "      <TD ALIGN='CENTER' VALIGN='BOTTOM' COLSPAN='3'>\n";
	print "        <A HREF='JavaScript:history.back()'><IMAGE WIDTH='95' HEIGHT='22' BORDER='0' SRC='./../img/bt_backd.gif' onMouseover=\"this.src='./../img/bt_backl.gif'\" onMouseout=\"this.src='./../img/bt_backd.gif'\"></A>\n";
	print "      </TD>\n";
	print "    </TR>\n";
	print "\n";
	print "  </TABLE>\n";
	print "</BODY>\n";
	print "</HTML>";
}
