#!/usr/local/bin/perl 


#-------------------------------------------------------  INIT VARIABLES
%in;						#-----  Xg

@userNames;					#[U[̔z
@titles;					#^Cg̔z
@messages;					#bZ[W̔z
@ips;						#IPAhX̔z
@update;					#XV̔z

$mesLength = 0;				#݂̃bZ[W̒

###########################################  Cuǂݍ
require "./neutralFnc.cgi";
require "./messages.sys";
require "./settings.sys";



#-------------------------------------------------------  MAIN
if( $ENV{'HTTP_REFERER'} ne $settings::REFERER_ADDRESS & $settings::REFERER_FLG == 1 )
{
	&showError( $messages::ERR_REFERER_TITLE, $messages::ERR_REFERER_MSG );
	exit(0);
}

#-----  p[^̎擾
getPram();

#-----  [U[o
$userName = &neutralFnc::tagToEscape( $in{"USER_NAME"} );

#-----  ^Cgo
$title = &neutralFnc::tagToEscape( $in{"TITLE"} );

#-----  bZ[Wo
$message = &neutralFnc::tagToEscape( $in{"MESSAGE"} );


#---------------------------------------------
#						eڂ̓̓`FbN
#---------------------------------------------
if( $userName eq "" )
{
	$userName = $messages::NO_NAME;
}

if( $title eq "" )
{
	$title = $messages::NO_TITLE;
}

if( $message eq "" )
{
	&showError( $messages::ERR_NOMESSAGE_TITLE, $messages::ERR_NOMESSAGE_MSG );
	exit(0);
}


#---------------------------------------------
#			t@CbNmFEbN
#---------------------------------------------
for( $index = 0; $index < $settings::LOCK_RETRY; $index++ )
{
	#-----  bNĂȂ
	if( &getFileLock() == 0 )
	{
		&setFileLock( 1 );
		last;
	}
	
	close(_LCFILE);
	
	#-----  bҋ@
	my( $now ) = time();
	while( ( $now + 1 ) > time() ){}
}


#-----  ܉̃gCɎsꍇ
if( $index >= $settings::LOCK_RETRY )
{
	&showError( $messages::ERR_BUSY_TITLE, $messages::ERR_BUSY_MSG );
	exit(0);
}


#---------------------------------------------
#			t@C̃I[vEǂݍݏ
#---------------------------------------------
#-----  bZ[Wt@C̃I[v
if( !open( _MSFILE, "+<" . $settings::FILENAME ) )
{
	&showError( $messages::ERR_DATNOOPEN_TITLE, $messages::ERR_DATNOOPEN_MSG );
	&setFileLock( 0 );
	
	exit(0);
}

$index    = 0;
$endIndex = 0;

#-----  bZ[Wt@C̓ez֊i[
while( <_MSFILE> )
{
	my( $tmpStr ) = $_;
	my( @tmpArray ) = split( /,/, $tmpStr );
	
	@userNames[$index] = @tmpArray[0];
	@titles[$index]    = @tmpArray[1];
	@messages[$index]  = @tmpArray[2];
	@ips[$index]       = @tmpArray[3];
	@update[$index]    = @tmpArray[4];
	
	#-----  R[hJEg
	$index++;
}

$mesLength = $index;		#-----  R[hێ
$fileCount = 1;				#-----  ꎞɓ݂ł悤Ƀt@CɕtJEg


#---------------------------------------------
#		ő咷𒴂R[hHTMLƂďo
#---------------------------------------------
#-----  ő匏𒴂Ă郌R[hHTMLƂďo
while( $mesLength >= $settings::MAX_MESSAGE_LENGTH )
{
	#-----  oJnCfbNXZo
	local( $tmpNum ) = $mesLength - $settings::MAX_MESSAGE_LENGTH;
	
	#-----  HTML t@C̃I[v
	if( !open( _HTMLFILE, "> ./../history/" . &neutralFnc::getLocalTime( 1 ) . "_" . $fileCount . ".html" ) )
	{
		&showError( $messages::ERR_FAILHTML_TITLE, $messages::ERR_FAILHTML_MSG );
		&setFileLock( 0 );
		exit(0);
	}
	
	#-----  bZ[W̏o
	&writeMessageResult( $tmpNum, $mesLength );
	
	#-----  HTMLt@C̃N[Y
	close( _HTMLFILE );
	
	#-----  oς݌ƂāÃ݂bZ[W̒L^ĩJE^͌ɗpj
	$endIndex  = $mesLength - $settings::MAX_MESSAGE_LENGTH;
	
	#-----  obZ[W̌
	$mesLength       = $mesLength - $settings::MAX_MESSAGE_LENGTH;
	
	#-----  ܂of[^݂鎞̂߂ɃJEgAbv
	$fileCount++;
}



#---------------------------------------------
#						t@C̏o
#---------------------------------------------
#-----  bZ[Wt@CNAĐVKȅ
truncate( _MSFILE, 0 );
seek( _MSFILE, 0, 0 );

print( _MSFILE $userName . "," );
print( _MSFILE $title . "," );
print( _MSFILE $message . "," );
print( _MSFILE ipCheck() . "," );
print( _MSFILE &neutralFnc::getLocalTime( 0 ) . "," );
print( _MSFILE "\n" );

$endIndex++;

#-----  ő咷R[h̎co
for( $index = 0; ( $index < ( $settings::MAX_MESSAGE_LENGTH - $endIndex ) ) & ( $index < $mesLength ); $index++ )
{
	print( _MSFILE @userNames[$index] . "," );
	print( _MSFILE @titles[$index] . "," );
	print( _MSFILE @messages[$index] . "," );
	print( _MSFILE @ips[$index] . "," );
	print( _MSFILE @update[$index] . "," );
	print( _MSFILE "\n" );
}

close( _MSFILE );

#-----  f[^t@C̃bN
&setFileLock( 0 );

#-----  y[W̑J
print "Location: ./result.cgi\n\n";

exit( 0 );


#-------------------------------------------------------
#  f[^t@CbN
#  		0: bN
#  				1: bN
#-------------------------------------------------------
sub setFileLock
{
	my( $tmpNum );
	
	if( $_[0] < 0 or $_[0] > 1 )
	{
		exit(0);
	}
	
	#-----  bNt@C̃I[v
	if( !open( _LCFILE, ">" . $settings::LOCKFILENAME ) )
	{
		&showError( $messages::ERR_LOKNOOPEN_TITLE, $messages::ERR_LOKNOOPEN_MSG );
		exit(0);
	}
	
	truncate( _LCFILE, 0 );
	seek( _LCFILE, 0, 0 );
	print( _LCFILE $_[0] );
	close( _LCFILE );
}


#-------------------------------------------------------
#  f[^t@C̃bN󋵂擾
#-------------------------------------------------------
sub getFileLock
{
	my( $lockStat );
	
	#-----  bNt@C̃I[v
	if( !open( _LCFILE, "<" . $settings::LOCKFILENAME ) )
	{
		&showError( $messages::ERR_LOKNOOPEN_TITLE, $messages::ERR_LOKNOOPEN_MSG );
		exit(0);
	}
	
	$lockStat = <_LCFILE>;
	close(_LCFILE);
	
	return $lockStat;
}


#-------------------------------------------------------
#  p[^[̎擾
#-------------------------------------------------------
sub getPram
{
	my($method) = $ENV{'REQUEST_METHOD'};
	local($qu, @in, $key, $val);

	#----- p[^擾
	if ($method eq 'GET')
	{
	$qu = $ENV{'QUERY_STRING'};
	}
	elsif ($method eq 'POST') 
	{
		read( STDIN, $qu, $ENV{'CONTENT_LENGTH'} );
	}

	local(@qu) = split(/&/, $qu);

	foreach (@qu) 
	{
		tr/+/ /;
		($key, $val) = split(/=/);

		$key =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack('c', hex($1))/ge;
		$val =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack('c', hex($1))/ge;
		$val =~ s/\r\n/\n/g;
	
		$in{$key} = $val;
    }
}

#-------------------------------------------------------  IPAhX`FbN֐
sub ipCheck
{
	if( $settings::IP_LOG == 0 )
	{
		return "";
	}
	
	return $ENV{"REMOTE_ADDR"};
}


#-------------------------------------------------------
#  G[bZ[Wo͊֐
#  		y[W^Cg
#  				bZ[W
#-------------------------------------------------------
sub showError
{
	print "Content-type:text/html\n\n";
	
	print "<HTML>\n";
	print "<HEAD>\n";
	print "<META http-equiv='Content-Type' content='text/html; charset=Shift_JIS'>\n";
	print "<LINK REL='stylesheet' TYPE='text/css' HREF='./../css/style_main.css'>\n";
	print "</HEAD>\n";
	print "\n";
	print "<BODY TEXT='#FFFFFF' BGCOLOR='#55000' LINK='#FFFFFF' ALINK='#FFFFFF' VLINK='#FFFFFF' CLASS='Body_Error'>\n";
	print "  <TABLE WIDTH='100%' HEIGHT='100%' BORDER='0' CELLSPACING='0' CELLPADDING='0'>\n";
	print "    <TR HEIGHT='20'>\n";
	print "      <TD BGCOLOR='#000000' VALIGN='TOP' CLASS='Line_Error'>\n";
	print "        <TABLE WIDTH='100%' HEIGHT='20' BORDER='0' CELLSPACING='1'>\n";
	print "          <TR BGCOLOR='#220000' CLASS='Box_Error'>\n";
	print "            <TD ALIGN='CENTER' VALIGN='MIDDLE'><FONT SIZE='3' COLOR='#FFFFFF'>\n";
	print "              <DIV CLASS='Txt_Reverse'><B>" . @_[0] . "</B></DIV></FONT>\n";
	print "            </TD>\n";
	print "          </TR>\n";
	print "        </TABLE>\n";
	print "      </TD>\n";
	print "    </TR>\n";
	print "    <TR HEIGHT='20'>\n";
	print "      <TD></TD>\n";
	print "    </TR>\n";
	print "    <TR HEIGHT='40'>\n";
	print "      <TD ALIGN='CENTER' VALIGN='TOP'><FONT SIZE='3'><DIV CLASS='Txt_Reverse'>\n";
	print "        " . @_[1] . "\n";
	print "      </DIV></FONT></TD>\n";
	print "    </TR>\n";
	print "    <TR>\n";
	print "      <TD ALIGN='CENTER' VALIGN='BOTTOM' COLSPAN='3'>\n";
	print "        <A HREF='JavaScript:history.back()'><IMAGE WIDTH='95' HEIGHT='22' BORDER='0' SRC='./../img/bt_backd.gif' onMouseover=\"this.src='./../img/bt_backl.gif'\" onMouseout=\"this.src='./../img/bt_backd.gif'\"></A>\n";
	print "      </TD>\n";
	print "    </TR>\n";
	print "\n";
	print "  </TABLE>\n";
	print "</BODY>\n";
	print "</HTML>";
}

#-------------------------------------------------------
#  HTML t@Co͊֐
#  		JnCfbNX
#  				ICfbNX
#-------------------------------------------------------
sub writeMessageResult
{
	print( _HTMLFILE "<HTML>\n" );
	print( _HTMLFILE "<HEAD>\n" );
	print( _HTMLFILE "<META http-equiv='Content-Type' content='text/html; charset=Shift_JIS'>\n" );
	print( _HTMLFILE "<LINK REL='stylesheet' TYPE='text/css' HREF='./../css/style_main.css'>\n" );
	print( _HTMLFILE "<SCRIPT SRC='./../javaScript/messages.js'></SCRIPT>\n" );
	print( _HTMLFILE "</HEAD>\n" );
	print( _HTMLFILE "\n" );
	print( _HTMLFILE "<BODY TEXT='#000055' BGCOLOR='#FFFFFF' LINK='#000055' ALINK='#FFFFFF' VLINK='#000055' CLASS='Body_Normal'>\n" );
	print( _HTMLFILE "  <TABLE WIDTH='100%' BORDER='0' CELLSPACING='0' CELLPADDING='0'>\n" );
	print( _HTMLFILE "    <TR>\n" );
	print( _HTMLFILE "      <TD COLSPAN='3'></TD>\n" );
	print( _HTMLFILE "    </TR>\n" );
	
	
	for( $index = $_[0]; $index < $_[1]; $index++ )
	{
		print( _HTMLFILE "    <TR HEIGHT='10'>\n" );
		print( _HTMLFILE "      <TD WIDTH='10'></TD>\n" );
		print( _HTMLFILE "      <TD>\n" );
		print( _HTMLFILE "        <TABLE WIDTH='100%' BORDER='0' CELLSPACING='0' CELLPADDING='1'><TR><TD WIDTH='100%' BGCOLOR='#000055' CLASS='Line_Normal'>\n" );
		print( _HTMLFILE "          <TABLE WIDTH='100%' BORDER='0' CELLSPACING='2' BGCOLOR='#AAAAFF' CLASS='Box_Normal'>\n" );
		print( _HTMLFILE "            <TR HEIGHT='20'>\n" );
		print( _HTMLFILE "              <TD>\n" );
		print( _HTMLFILE "                <TABLE HEIGHT='100%' BORDER='0' CELLSPACING='0' CELLPADDING='1' BGCOLOR='#000055' CLASS='Line_Normal'><TR><TD>\n" );
		print( _HTMLFILE "                  <TABLE HEIGHT='100%' BORDER='0' CELLSPACING='0' BGCOLOR='#FFFFFF' CLASS='Body_Normal'><TR><TD>\n" );
		print( _HTMLFILE "                    <FONT SIZE='3'><DIV CLASS='Txt_Normal'>\n" );
		print( _HTMLFILE "                      &nbsp;<IMG SRC='./../img/ball3.gif' WIDTH='11' HEIGHT='8'>&nbsp; " . $titles[$index] . "\n" );
		print( _HTMLFILE "                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n" );
		print( _HTMLFILE "                    </DIV></FONT>\n" );
		print( _HTMLFILE "                  </TD></TR></TABLE>\n" );
		print( _HTMLFILE "                </TD></TR></TABLE>\n" );
		print( _HTMLFILE "              </TD>\n" );
		print( _HTMLFILE "            </TR>\n" );
		print( _HTMLFILE "            <TR>\n" );
		print( _HTMLFILE "              <TD ALIGN='LEFT' VALIGN='TOP'>\n" );
		print( _HTMLFILE "                <TABLE WIDTH='100%' BORDER='0' CELLSPACING='0' CELLPADDING='0'>\n" );
		print( _HTMLFILE "                  <TR>\n" );
		print( _HTMLFILE "                    <TD WIDTH='10'></TD>\n" );
		print( _HTMLFILE "                    <TD ALIGN='LEFT'><FONT SIZE='3'><DIV CLASS='Txt_Normal'>\n" );
		print( _HTMLFILE "                      " . $messages[$index] . "\n" );
		print( _HTMLFILE "                    </DIV></FONT></TD>\n" );
		print( _HTMLFILE "                  </TR>\n" );
		print( _HTMLFILE "                </TABLE>\n" );
		print( _HTMLFILE "              </TD>\n" );
		print( _HTMLFILE "            </TR>\n" );
		print( _HTMLFILE "            <TR HEIGHT='20'>\n" );
		print( _HTMLFILE "              <TD ALIGN='RIGHT'><FONT SIZE='3'><DIV CLASS='Txt_Normal'>\n" );
		print( _HTMLFILE "                <B>[U[F" . $userNames[$index] . "</B>&nbsp;&nbsp;" . $update[$index] . "\n" );
		print( _HTMLFILE "              </DIV></FONT></TD>\n" );
		print( _HTMLFILE "            </TR>\n" );
		print( _HTMLFILE "          </TABLE>\n" );
		print( _HTMLFILE "        </TD></TR></TABLE>\n" );
		print( _HTMLFILE "      </TD>\n" );
		print( _HTMLFILE "      <TD WIDTH='10'></TD>\n" );
		print( _HTMLFILE "    </TR>\n" );
		print( _HTMLFILE "    <TR HEIGHT='5'>\n" );
		print( _HTMLFILE "      <TD COLSPAN='2'></TD>\n" );
		print( _HTMLFILE "    </TR>\n" );
	}
	
	
	print( _HTMLFILE "  </TABLE>\n" );
	print( _HTMLFILE "</BODY>\n" );
	print( _HTMLFILE "</HTML>\n" );
}
